#include <iostream>

#include <crdb.h>

int main(int argc, char* argv[]) {

    CRDataset ds;

    if(argc != 2) {
        std::cerr << argv[0] << "  <data-file>" << std::endl;
        return EXIT_FAILURE;
    }
    ds.parse_file(argv[1]);

    for (auto pd : ds) {
        auto& d = *pd;
        std::cout << "exp:\t" << d.experiment << std::endl;
        std::cout << "time:\t" << d.time << std::endl;
        std::cout << "cite:\t" << d.cite << std::endl;
        std::cout << "link:\t" << d.link << std::endl;
        std::cout << "x:\t" << d.x_quantity << " [ " << d.x_unit << " ]"
                  << std::endl;
        std::cout << "y:\t" << d.y_quantity << " [ " << d.y_unit << " ]"
                  << std::endl;
        std::cout << "scale:\t" << d.scale << std::endl;
        std::cout << "hasbin:\t" << d.has_bin << std::endl;
        std::cout << "skewed:\t" << d.skewed_error << std::endl;
        std::cout << "rig:\t" << d.use_rigidity << std::endl;
        std::cout << "phi:\t" << d.phi << std::endl;
        std::cout << "dist:\t" << d.solar_dist << std::endl;
        if (d.known_species) {
            std::cout << "num:";
            for (const auto& n : d.num_list) {
                std::cout << '\t' + n.str();
            }
            if (d.is_ratio) {
                std::cout << std::endl << "den:";
                for (const auto& n : d.den_list) {
                    std::cout << '\t' + n.str();
                }
            }
            std::cout << std::endl;
        }

        std::cout << std::scientific;
        std::cout << "#x\t\t#y\t\t#ey1\t\t#ey2\t\t#x_lower\t#x_upper" << std::endl;
        for (const auto& dp : d) {
            std::cout << dp.x << '\t' << dp.y << '\t'             //
                      << dp.ey1 << '\t' << dp.ey2 << '\t'         //
                      << dp.x_lower << '\t' << dp.x_upper << '\t' //
                      << std::endl;
        }
        std::cout << "total:\t" << d.size() << std::endl;
    }

    return 0;
}
